from enum import Enum

class SerialMessage(Enum):
    MSG_INVALID                             = 0
    MSG_GET_SYSTEM_FW_VERSION               = 1
    MSG_GET_CHASSIS_MODEL_NUMBER            = 2
    MSG_GET_CHASSIS_ESN                     = 3
    MSG_GET_MFG_DATE                        = 4
    MSG_RESTORE_FACTORY_DEFAULTS            = 5
    MSG_SAVE_DEFAULTS                       = 6
    MSG_SET_REAR_PANEL_DATA_SOURCE          = 7
    MSG_GET_REAR_PANEL_DATA_SOURCE          = 8
    MSG_SET_BT_NAME                         = 9
    MSG_GET_BT_NAME                         = 10
    MSG_GET_BT_ADDR                         = 11
    MSG_TRANSACTION_DONE                    = 12
    MSG_START_BT_INQUIRY                    = 13
    MSG_BT_INQUIRY_RESULT                   = 14
    MSG_GET_DETECTED_DEVICES_LIST           = 15
    MSG_START_BT_CONNECTION                 = 16
    MSG_DISCONNECT_ALL                      = 17
    MSG_SET_BT_ROLE                         = 18
    MSG_GET_BT_ROLE                         = 19
    MSG_SET_PROFILE_CODEC                   = 20
    MSG_GET_PROFILE_CODEC_LIST              = 21
    MSG_GET_OPEN_LINK_LIST                  = 22
    MSG_GET_PAIR_LIST                       = 23
    MSG_CLEAR_PAIR_LIST                     = 24
    MSG_SET_A2DP_AUDIO_STATE                = 25
    MSG_SET_HFP_AUDIO_STATE                 = 26
    MSG_GET_BT_FW_VERSION                   = 27
    MSG_RESET_BT                            = 28
    MSG_SET_REAR_PANEL_AUDIO_SAMPLING_RATE  = 29
    MSG_GET_REAR_PANEL_AUDIO_SAMPLING_RATE  = 30
    MSG_SET_BT_COMMAND_TIMEOUT              = 31
    MSG_GET_BT_COMMAND_TIMEOUT              = 32
    MSG_SET_AVRCP_VOLUME                    = 33
    MSG_GET_AVRCP_VOLUME                    = 34
    MSG_SET_HFP_VOLUME                      = 35
    MSG_GET_HFP_VOLUME                      = 36
    MSG_SET_MITM_STATE                      = 37
    MSG_GET_MITM_STATE                      = 38
    MSG_SET_BT_PIN                          = 39
    MSG_GET_BT_PIN                          = 40
    MSG_GET_BT_LINK_KEY                     = 41
    MSG_GET_RSSI                            = 42

payload_identifier_lookup = {
    SerialMessage.MSG_INVALID                               : '0',
    SerialMessage.MSG_GET_SYSTEM_FW_VERSION                 : '2',
    SerialMessage.MSG_GET_CHASSIS_MODEL_NUMBER              : '4',
    SerialMessage.MSG_GET_CHASSIS_ESN                       : '6',
    SerialMessage.MSG_GET_MFG_DATE                          : '8',
    SerialMessage.MSG_RESTORE_FACTORY_DEFAULTS              : '9',
    SerialMessage.MSG_SAVE_DEFAULTS                         : chr(ord('0') + 10),
    SerialMessage.MSG_SET_REAR_PANEL_DATA_SOURCE            : chr(ord('0') + 20),
    SerialMessage.MSG_GET_REAR_PANEL_DATA_SOURCE            : chr(ord('0') + 21),
    SerialMessage.MSG_SET_BT_NAME                           : chr(ord('0') + 23),
    SerialMessage.MSG_GET_BT_NAME                           : chr(ord('0') + 24),
    SerialMessage.MSG_GET_BT_ADDR                           : chr(ord('0') + 25),
    SerialMessage.MSG_TRANSACTION_DONE                      : chr(ord('0') + 26),
    SerialMessage.MSG_START_BT_INQUIRY                      : chr(ord('0') + 27),
    SerialMessage.MSG_BT_INQUIRY_RESULT                     : chr(ord('0') + 28),
    SerialMessage.MSG_GET_DETECTED_DEVICES_LIST             : chr(ord('0') + 29),
    SerialMessage.MSG_START_BT_CONNECTION                   : chr(ord('0') + 30),
    SerialMessage.MSG_DISCONNECT_ALL                        : chr(ord('0') + 31),
    SerialMessage.MSG_SET_BT_ROLE                           : chr(ord('0') + 32),
    SerialMessage.MSG_GET_BT_ROLE                           : chr(ord('0') + 33),
    SerialMessage.MSG_SET_PROFILE_CODEC                     : chr(ord('0') + 34),
    SerialMessage.MSG_GET_PROFILE_CODEC_LIST                : chr(ord('0') + 35),
    SerialMessage.MSG_GET_OPEN_LINK_LIST                    : chr(ord('0') + 36),
    SerialMessage.MSG_GET_PAIR_LIST                         : chr(ord('0') + 37),
    SerialMessage.MSG_CLEAR_PAIR_LIST                       : chr(ord('0') + 38),
    SerialMessage.MSG_SET_A2DP_AUDIO_STATE                  : chr(ord('0') + 39),
    SerialMessage.MSG_SET_HFP_AUDIO_STATE                   : chr(ord('0') + 40),
    SerialMessage.MSG_GET_BT_FW_VERSION                     : chr(ord('0') + 41),
    SerialMessage.MSG_RESET_BT                              : chr(ord('0') + 42),
    SerialMessage.MSG_SET_REAR_PANEL_AUDIO_SAMPLING_RATE    : chr(ord('0') + 43),
    SerialMessage.MSG_GET_REAR_PANEL_AUDIO_SAMPLING_RATE    : chr(ord('0') + 44),
    SerialMessage.MSG_SET_BT_COMMAND_TIMEOUT                : chr(ord('0') + 45),
    SerialMessage.MSG_GET_BT_COMMAND_TIMEOUT                : chr(ord('0') + 46),
    SerialMessage.MSG_SET_AVRCP_VOLUME                      : chr(ord('0') + 47),
    SerialMessage.MSG_GET_AVRCP_VOLUME                      : chr(ord('0') + 48),
    SerialMessage.MSG_SET_HFP_VOLUME                        : chr(ord('0') + 49),
    SerialMessage.MSG_GET_HFP_VOLUME                        : chr(ord('0') + 50),
    SerialMessage.MSG_SET_MITM_STATE                        : chr(ord('0') + 51),
    SerialMessage.MSG_GET_MITM_STATE                        : chr(ord('0') + 52),
    SerialMessage.MSG_SET_BT_PIN                            : chr(ord('0') + 53),
    SerialMessage.MSG_GET_BT_PIN                            : chr(ord('0') + 54),
    SerialMessage.MSG_GET_BT_LINK_KEY                       : chr(ord('0') + 55),
    SerialMessage.MSG_GET_RSSI                              : chr(ord('0') + 56)
}
